MainProgram:
  gosub Initialize
  gosub Demo
end
//===================================================================
Demo:
  SetColor Black,BG
  print
  print
  print "                            SERVO MOTOR SIMULATION"
  print
  print " This program simulates a 90 degree servo motor which can be moved to specific postions"
  print " by sending it pulses between 1000 and 2000 microseconds.  You do this by setting the"
  print " variable PulseWidth to the desired number and calling the subroutine Servo.  The demo"
  print " program simply moves the motor through its entire range.  As the motor moves, it "
  print " moves two eyes much like the operation of our humanoid robot (see our other videos)."
  print
  print " Your assignment is to utilze the RobotBASIC camera and vision commands to make the"
  print " eyes follow an object being moved in front of the camera (see our Vision Video)."
  while true
    PulseWidth = 2000\gosub Servo
    PulseWidth = 1000\gosub Servo
  wend
return
//===================================================================
Initialize:
  x = 70\y=350
  CurPos = 1000
  Incr = DtoR(90.0/100)
  Dim Mot[4,5]
  Data Points;-10,0,0,0,0,  0,10,0,0,0,  25,0,0,0,0,  0,-10,0,0,0
  mCopy Points,Mot
  Data View; 50,120,20,100,400,300
  angle=DtoR(90)\gosub Rot
  ge3Dto2DA Mot,View
  SetColor black,gray
  IndColr = 16756912
  FitBMP "ServoMot",299,270,200,200
  ReadPixel 350,300,BG
  ClearScr BG
  FitBMP "ServoMot",299,270,200,200
  Rectangle 299,270,499,295,BG,BG
  Rectangle 299,270,340,380,BG,BG
  Rectangle 465,270,499,400,BG,BG
  LineWidth 2
  Circle 90,390,160,460,black,white
  Circle 190,390,260,460,black,white
  SaveScr 0,250,530,500
  DelTime = 0
  T = Timer()-200
  Flip on
  ClearScr BG
return
//===================================================================
Rot:
  for i = 0 to 3
    geRotVz Mot[i,0],Mot[i,1],Mot[i,3],angle,a,b,c 
    Mot[i,0]=a
    Mot[i,1]=b
    Mot[i,3]=c
  next
return   
//===================================================================
Servo:
  // PulseWidth must be between 1000 and 2000 microseconds
  if !Within(PulseWidth,1000,2000) then return
  Moves = Round((CurPos-PulseWidth)/10)
  CurPos=PulseWidth
  for k = 0 to Abs(Moves)
    if Moves>0
      angle=Incr
      x=x+.6
    else
      angle=-Incr
      x=x-.6
    endif
    gosub Rot 
    ge3Dto2DA Mot,View 
    RestoreScr 0,250
    LineWidth 2
    Line Mot[0,3],Mot[0,4],Mot[3,3],Mot[3,4],1,black
    for i = 2 to 0
      LineTo Mot[i,3],Mot[i,4],1,black
    next
    tx=Mot[2,3]\ty=Mot[2,4]
    Circle tx-4,ty-3,tx+4,ty+3,black,IndColr
    FloodFill2 400,300,IndColr
    circle 397,298,403,302,Black,Black
    Line x,y,x+180,y
    LineTo x+180+40,y+20
    LineTo x+40,y+20
    LineTo x,y
    FloodFill2 x+50,y+2,IndColr
    Line x+110,y+20,x+110,y+25
    Line x+110,y+10,x+110,y-35
    LineTo tx,ty-35     // change
    LineTo tx,ty+35
    Line 125,425,x+50,y+50
    LineTo x+50,y+20
    Line x+50,y+10,x+50,y+5
    
    Line 225,425,x+150,y+50
    LineTo x+150,y+20
    Line x+150,y+10,x+150,y+5
    Circle 90,390,160,460,black,white
    Circle 190,390,260,460,black,white
    eyeX=215-.7*(85+x)
    Circle eyeX-7,425-7,eyeX+7,425+7,Black,Black
    eyeX=eyeX+100
    Circle eyeX-7,425-7,eyeX+7,425+7,Black,Black
    flip
  next
return
//===================================================================
